Tasks - List

Recommended tasks that will help improve the security of the subscription proactively

GET https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Security/tasks?api-version=2015-06-01-preview
GET https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Security/tasks?api-version=2015-06-01-preview&$filter={$filter}

URI Parameters

Name In Required Type Description
subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

$filter
query

string

OData filter. Optional.

Responses

Name Type Description
200 OK

SecurityTaskList

The request has succeeded.

Other Status Codes

Common.CloudError

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Get security recommendations tasks

Sample request

GET https://management.azure.com/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/providers/Microsoft.Security/tasks?api-version=2015-06-01-preview

Sample response

{
  "value": [
    {
      "name": "62609ee7-d0a5-8616-9fe4-1df5cca7758d",
      "type": "Microsoft.Security/locations/tasks",
      "id": "/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/providers/Microsoft.Security/locations/westeurope/tasks/62609ee7-d0a5-8616-9fe4-1df5cca7758d",
      "properties": {
        "creationTimeUtc": "2018-03-05T10:42:03.9935508Z",
        "lastStateChangeTimeUtc": "2018-03-05T10:42:03.9935508Z",
        "securityTaskParameters": {
          "name": "NetworkSecurityGroupMissingOnSubnet",
          "location": "uksouth",
          "resourceGroup": "myRg",
          "resourceId": "/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/resourceGroups/myRg/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/default",
          "resourceName": "default",
          "resourceParent": "vnet1",
          "resourceType": "Subnet",
          "uniqueKey": "/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/resourceGroups/myRg/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/default"
        },
        "state": "Active",
        "subState": "NA"
      }
    },
    {
      "name": "d55b4dc0-779c-c66c-33e5-d7bce24c4222",
      "type": "Microsoft.Security/locations/tasks",
      "id": "/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/resourceGroups/myRg/providers/Microsoft.Security/locations/westeurope/tasks/d55b4dc0-779c-c66c-33e5-d7bce24c4222",
      "properties": {
        "creationTimeUtc": "2018-04-02T11:41:27.0541014Z",
        "lastStateChangeTimeUtc": "2018-04-02T11:41:27.0541014Z",
        "securityTaskParameters": {
          "name": "EncryptionOnVm",
          "isDataDiskEncrypted": false,
          "isOsDiskEncrypted": false,
          "resourceId": "/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/resourceGroups/myRg/providers/Microsoft.Compute/virtualMachines/vm1",
          "severity": "High",
          "uniqueKey": "EncryptionOnVmTaskParameters_/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/resourceGroups/myRg/providers/Microsoft.Compute/virtualMachines/vm1",
          "vmId": "/subscriptions/20ff7fc3-e762-44dd-bd96-b71116dcdc23/resourceGroups/myRg/providers/Microsoft.Compute/virtualMachines/vm1",
          "vmName": "vm1"
        },
        "state": "Active",
        "subState": "NA"
      }
    }
  ]
}

Definitions

Name Description
Common.CloudError

Common error response for all Azure Resource Manager APIs to return error details for failed operations. (This also follows the OData error response format.).

Common.CloudErrorBody

The error detail.

createdByType

The type of identity that created the resource.

ErrorAdditionalInfo

The resource management error additional info.

SecurityTask

Security task that we recommend to do in order to strengthen security

SecurityTaskList

List of security task recommendations

SecurityTaskParameters

Changing set of properties, depending on the task type that is derived from the name field

systemData

Metadata pertaining to creation and last modification of the resource.

Common.CloudError

Common error response for all Azure Resource Manager APIs to return error details for failed operations. (This also follows the OData error response format.).

Name Type Description
error.additionalInfo

ErrorAdditionalInfo[]

The error additional info.

error.code

string

The error code.

error.details

Common.CloudErrorBody[]

The error details.

error.message

string

The error message.

error.target

string

The error target.

Common.CloudErrorBody

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

Common.CloudErrorBody[]

The error details.

message

string

The error message.

target

string

The error target.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

SecurityTask

Security task that we recommend to do in order to strengthen security

Name Type Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties.creationTimeUtc

string (date-time)

The time this task was discovered in UTC

properties.lastStateChangeTimeUtc

string (date-time)

The time this task's details were last changed in UTC

properties.securityTaskParameters

SecurityTaskParameters

Changing set of properties, depending on the task type that is derived from the name field

properties.state

string

State of the task (Active, Resolved etc.)

properties.subState

string

Additional data on the state of the task

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

SecurityTaskList

List of security task recommendations

Name Type Description
nextLink

string

The URI to fetch the next page.

value

SecurityTask[]

The SecurityTask items on this page

SecurityTaskParameters

Changing set of properties, depending on the task type that is derived from the name field

Name Type Description
name

string

Name of the task type

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.